Index: external/fastjet/contribs/Nsubjettiness/COPYING
===================================================================
--- external/fastjet/contribs/Nsubjettiness/COPYING	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/contribs/Nsubjettiness/COPYING	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -12,7 +12,15 @@
 to
 
+N-subjettiness:
   arXiv:1011.2268
   arXiv:1108.2701
 
+Winner-take-all axes:
+  arXiv:1310.7584
+  arXiv:1401.2158
+
+XCone:
+  arXiv:1508.01516
+  arXiv:1508.01518
 
 
Index: external/fastjet/contribs/Nsubjettiness/ChangeLog
===================================================================
--- external/fastjet/contribs/Nsubjettiness/ChangeLog	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/contribs/Nsubjettiness/ChangeLog	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -1,2 +1,138 @@
+2015-09-28 <jthaler>
+   Updated NEWS for 2.2.1 release.
+2015-09-18 <jthaler>
+   Fixed duplicate XConePlugin entry in Makefile.
+2015-08-20 <jthaler>
+   Trying to fix "abs" bug in ExtraRecombiners.cc
+2015-08-19 <jthaler>
+   Adding arXiv numbers to XCone papers
+   Used this_jet in example_basic_usage.
+   Fixed typo in example_advanced_usage header.
+   Added copy/paste code in README file.
+2015-08-13 <jthaler>
+   Ready for 2.2.0 release
+2015-07-23 <jthaler>
+   Fixed typo in GenET_GenKT_Axes error message
+   Added _too_few_axes_warning to ExclusiveJetAxes and ExclusiveCombinatorialJetAxes
+   Switched to ../data/single_event_ee.dat for make check
+2015-07-20 <jthaler>
+   Renamed WinnerTakeAllRecombiner.hh/cc to ExtraRecombiners.hh/cc
+   Added _too_few_axes_warning to HardestJetAxes
+   Added GenKT_Axes and OnePass_GenKT_Axes and Comb_GenKT_Axes (using E-scheme recombination).
+   Added warning about p < 0 or delta <=0 in GenKT axes finders.
+   Added warning about beta <= 0 in all measures.
+2015-07-10 <jthaler>
+   Putting in small tweaks in documentation to get ready for 2.2 release candidate 1.
+2015-06-15 <jthaler>
+   Starting doxygen file for eventual improved documentation.
+   Starting long process of improving documentation throughout.
+   Made the basic usage file a bit easier to read.
+   Adding in LimitedWarnings for old style constructors
+2015-06-12 <jthaler>
+   Synchronized definition of new measures with XCone paper.
+   In MeasureDefinition, added default values of jet_distance_squared and beam_distance_squared for cases where we don't want to optimize specifically.
+   Fixed bug in OriginalGeometricMeasure and ModifiedGeometric Measure
+   Commented out DeprecatedGeometricMeasure and DeprecatedGeometricCutoffMeasure since they were only causing confusion
+2015-05-26 <TJW>
+   Removed axis_scale_factor(), added bool to calculate this value if needed to save computation time
+   Defined small offset in denominator of axis scaling according to accuracy of refinement
+   Updated advanced examples to include tau values and number of jet constituents
+2015-05-25 <jthaler>
+   Clean up of AxesDefinition
+   Splitting get_axes into get_starting_axes and get_refined axes
+   Putting in proper noise ranges (hopefully) for MultiPass
+   Clean up of MeasureDefinition, rename jet_gamma to beam_gamma
+   Put in zero checking for jet_distance in ConicalGeometricMeasure
+   Added in ConicalMeasure for consistency
+   Changing OnePass Minimization to allow for temporary uphill
+2015-05-24 <TJW>
+   Added Combinatorial GenET_GenKT_Axes and MultiPass_Manual_Axes
+   Moved Axes refining information into MeasureDefinition, associated each measure with corresponding axes refiner
+   Moved get_one_pass_axes into MeasureDefinition, removed any mention of Npass
+   Moved all information on number of passes to AxesDefinition
+   Made AxesRefiner.hh/.cc into defunct files
+2015-05-22 <jthaler>
+   Cleaning out commented text.  Renaming classes to be consistent with recommended usage.
+2015-05-22 <TJW>
+   Added XConePlugin as a specific implementation of NjettinessPlugin
+   Added usage of XCone beta = 1.0 and beta = 2.0 to both basic and advanced example files
+   Added OriginalGeometric, ModifiedGeometric, ConicalGeometric, and XCone measures to list of test measures
+   Added OnePass_GenRecomb_GenKT_Axes to list of test axes
+   Added description to XCone measure in MeasureDefinition
+2015-05-21 <TJW>
+   Updated minimization scheme to avoid divide-by-zero errors
+   Fixed various factors of 2 in the definition of the measures
+2015-04-19 <TJW>
+   Fixed bug in minimization scheme for GeneralAxesRefiner
+   Moved measure_type to DefaultMeasure, removed geometric measure from e+e- example file
+2015-03-22 <TJW>
+   Added OriginalGeometricMeasure and ModifiedGeometricMeasure definitions
+   Changed all instances of GeometricMeasure to DeprecatedGeometricMeasure, and added error statements
+   Made GeneralAxesRefiner the default axes refiner for Measure Definition, overwritten by DefaultMeasure and GeometricMeasure
+   Created DefaultMeasure class for all the conical measure subclasses
+   Separated out e+e- and pp measures into separate example files
+2015-03-09 <TJW>
+   Added ConicalGeometric measures with jet_beta and jet_gamma definitions
+   Added XCone measures derived from ConicalGeometric with jet_gamma = 1.0
+   Added GeneralAxesRefiner for use with any measure (currently defined with XCone measure)
+   Added axes_numerator in MeasureDefinition to define the momentum scaling for minimization (currently only defined for Conical Geometric measure)
+2014-11-28 <TJW>
+   Minor change to default parameters in axes definition
+2014-10-08 <TJW>
+   Updated example file with new e+e- measure definitions
+   Added measure type to measure definition descriptions
+   Changed order of parameters in new axes definitions
+   Added standard C++ epsilon definition to GeneralERecombiner
+2014-10-07 <TJW>
+   Updated example_advanced_usage with new axes choices
+   Reversed inheritance of NormalizedMeasure and NormalizedCutoffMeasure (and Geometric) back to original
+   Storing _RcutoffSq as separate variable, and recalculating it in NormalizedMeasure 
+   Cleaning up ExclusiveCombinatorialJetAxes and added comments to explain the process
+   Fixed memory leaks using delete_recombiner_when_unused()
+   Fixed manual axes bug in Njettiness
+   Cleaned up enum definitions
+2014-10-01 <TJW>
+   Added new parameterized recombination scheme to Winner-Take-All recombiner
+   Created Winner-Take-All GenKT and general Recomb GenKT axes finders and onepass versions
+   Created new N choose M minimization axis finder, created N choose M WTA GenKT axis finder as example
+   Removed NPass as constructor argument in AxesDefinition, made it set through protected method
+   Removed TauMode as constructor argument in MeasureDefinition, made it set through protected method
+   Flipped inheritance of NormalizedMeasure and NormalizedCutoffMeasure (same for Geometric) to remove error of squaring the integer maximum
+   Created new MeasureType enum to allow user to choose between pp and ee variables (ee variables need testing)
+   Updated MeasureDefinition constructors to take in extra MeasureType parameter (but defaulted to pp variables)
+   Added new Default TauMode argument 
+   Fixed unsigned integers in various places
+   Added setAxes method to NjettinessPlugin
+2014-08-26 <JDT>
+   Enhanced TauComponents to include more infomation
+   NjettinessExtras now inherits from TauComponents
+   Removed getPartition from Njettiness, to avoid code duplication
+   Fixed double calculating issue in NjettinessPlugin::run_clustering()
+   Now AxesDefinition can use measure information without running AxesRefiner
+   Added TauStructure so the jets returned by TauComponents can know their tau value.
+2014-08-25 <JDT>
+   Merged MeasureDefinition and MeasureFunction into new MeasureDefinition.
+   Merged StartingAxesFinder and AxesDefinition into new AxesDefinition.
+   Renamed AxesFinder.cc/hh to AxesRefiner.cc/hh
+   Renamed NjettinessDefinition.cc/hh to AxesDefinition.cc/hh
+   Renamed MeasureFunction.cc/hh to MeasureDefinition.cc/hh
+   Renaming result() function in MeasureDefinition to be consistent with Nsubjettiness interface.
+   Split off TauComponents into separate header
+   Added TauPartition class for readability of partitioning
+   Moved NjettinessExtras into TauComponents, as this will eventually be the logical location
+   Added cross check of new MeasureDefinition and AxesDefinition in example_advanced_usage.
+   Lots of comments updated.
+   Changed version number to 2.2.0-alpha-dev, since this is going to be a bigger update than I had originally thought
+2014-08-20 <JDT>
+   Incorporated code in NjettinessPlugin to handle FJ3.1 treatment of auto_ptr (thanks Gregory)
+   Changed version number to 2.1.1-alpha-dev
+   Split AxesFinder into StartingAxesFinder and RefiningAxesFinder for clarity.
+   Manual axes mode now corresponds to a NULL StartingAxesFinder in Njettiness (so removed AxesFinderFromUserInput)
+   Added AxesRefiningMode to make selection of minimization routine more transparent in Njettiness
+   Moved sq() to more appropriate place in AxesFinder.hh
+   Rearranged Nsubjettiness.hh to make the old code less visible.
+   Renamed AxesFinderFromOnePassMinimization -> AxesFinderFromConicalMinimization
+   Renamed DefaultUnnormalizedMeasureFunction -> ConicalUnnormalizedMeasureFunction
+   Removed supportsMultiPassMinimization() from MeasureDefinition since any One Pass algorithm can be multipass.
 2014-07-09 <JDT>
    Changed version for 2.1.0 release.
Index: external/fastjet/contribs/Nsubjettiness/ExtraRecombiners.cc
===================================================================
--- external/fastjet/contribs/Nsubjettiness/ExtraRecombiners.cc	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
+++ external/fastjet/contribs/Nsubjettiness/ExtraRecombiners.cc	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -0,0 +1,103 @@
+//  Nsubjettiness Package
+//  Questions/Comments?  jthaler@jthaler.net
+//
+//  Copyright (c) 2011-14
+//  Jesse Thaler, Ken Van Tilburg, Christopher K. Vermilion, and TJ Wilkason
+//
+//  $Id: ExtraRecombiners.cc 842 2015-08-20 13:44:31Z jthaler $
+//----------------------------------------------------------------------
+// This file is part of FastJet contrib.
+//
+// It is free software; you can redistribute it and/or modify it under
+// the terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 2 of the License, or (at
+// your option) any later version.
+//
+// It is distributed in the hope that it will be useful, but WITHOUT
+// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
+// License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this code. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+
+#include "ExtraRecombiners.hh"
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+namespace contrib{
+  
+std::string GeneralEtSchemeRecombiner::description() const {
+   return "General Et-scheme recombination";
+}
+
+// recombine pa and pb according to a generalized Et-scheme parameterized by the power delta
+void GeneralEtSchemeRecombiner::recombine(const fastjet::PseudoJet & pa, const fastjet::PseudoJet & pb, fastjet::PseudoJet & pab) const {
+   
+   // Define new weights for recombination according to delta
+   // definition of ratio done so that we do not encounter issues about numbers being too large for huge values of delta
+   double ratio;
+   if (std::abs(_delta - 1.0) < std::numeric_limits<double>::epsilon()) ratio = pb.perp()/pa.perp(); // save computation time of pow()
+   else ratio = pow(pb.perp()/pa.perp(), _delta);
+   double weighta = 1.0/(1.0 + ratio);
+   double weightb = 1.0/(1.0 + 1.0/ratio);
+   
+   double perp_ab = pa.perp() + pb.perp();
+   // reweight the phi and rap sums according to the weights above
+   if (perp_ab != 0.0) {
+      double y_ab = (weighta * pa.rap() + weightb * pb.rap());
+      
+      double phi_a = pa.phi(), phi_b = pb.phi();
+      if (phi_a - phi_b > pi)  phi_b += twopi;
+      if (phi_a - phi_b < -pi) phi_b -= twopi;
+      double phi_ab = (weighta * phi_a + weightb * phi_b);
+      
+      pab.reset_PtYPhiM(perp_ab, y_ab, phi_ab);
+      
+   }
+   else {
+      pab.reset(0.0,0.0,0.0,0.0);
+   }
+}
+
+
+std::string WinnerTakeAllRecombiner::description() const {
+   return "Winner-Take-All recombination";
+}
+
+// recombine pa and pb by creating pab with energy of the sum of particle energies in the direction of the harder particle
+// updated recombiner to use more general form of a metric equal to E*(pT/E)^(alpha), which reduces to pT*cosh(rap)^(1-alpha)
+// alpha is specified by the user. The default is alpha = 1, which is the typical behavior. alpha = 2 provides a metric which more 
+// favors central jets
+void WinnerTakeAllRecombiner::recombine(const fastjet::PseudoJet & pa, const fastjet::PseudoJet & pb, fastjet::PseudoJet & pab) const {
+   double a_pt = pa.perp(), b_pt = pb.perp(), a_rap = pa.rap(), b_rap = pb.rap();
+   
+   // special case of alpha = 1, everything is just pt (made separate so that pow function isn't called)
+   if (_alpha == 1.0) {
+      if (a_pt >= b_pt) {
+         pab.reset_PtYPhiM(a_pt + b_pt, a_rap, pa.phi());
+      }
+      else if (b_pt > a_pt) {
+         pab.reset_PtYPhiM(a_pt + b_pt, b_rap, pb.phi());
+      }
+   }
+
+   // every other case uses additional cosh(rap) term
+   else {
+      double a_metric = a_pt*pow(cosh(a_rap), 1.0-_alpha);
+      double b_metric = b_pt*pow(cosh(b_rap), 1.0-_alpha);
+      if (a_metric >= b_metric) {
+   	  double new_pt = a_pt + b_pt*pow(cosh(b_rap)/cosh(a_rap), 1.0-_alpha);
+   	  pab.reset_PtYPhiM(new_pt, a_rap, pa.phi());
+      }
+      if (b_metric > a_metric) {
+   	  double new_pt = b_pt + a_pt*pow(cosh(a_rap)/cosh(b_rap), 1.0-_alpha);
+   	  pab.reset_PtYPhiM(new_pt, b_rap, pb.phi());
+      }
+   }
+}
+
+} //namespace contrib
+
+FASTJET_END_NAMESPACE
Index: external/fastjet/contribs/Nsubjettiness/ExtraRecombiners.hh
===================================================================
--- external/fastjet/contribs/Nsubjettiness/ExtraRecombiners.hh	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
+++ external/fastjet/contribs/Nsubjettiness/ExtraRecombiners.hh	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -0,0 +1,103 @@
+//  Nsubjettiness Package
+//  Questions/Comments?  jthaler@jthaler.net
+//
+//  Copyright (c) 2011-14
+//  Jesse Thaler, Ken Van Tilburg, Christopher K. Vermilion, and TJ Wilkason
+//
+//  $Id: ExtraRecombiners.hh 828 2015-07-20 14:52:06Z jthaler $
+//----------------------------------------------------------------------
+// This file is part of FastJet contrib.
+//
+// It is free software; you can redistribute it and/or modify it under
+// the terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 2 of the License, or (at
+// your option) any later version.
+//
+// It is distributed in the hope that it will be useful, but WITHOUT
+// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
+// License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this code. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+
+#ifndef __FASTJET_CONTRIB_WINNERTAKEALLRECOMBINER_HH__
+#define __FASTJET_CONTRIB_WINNERTAKEALLRECOMBINER_HH__
+
+#include "fastjet/PseudoJet.hh"
+#include "fastjet/JetDefinition.hh"
+
+#include <cmath>
+#include <vector>
+#include <list>
+#include <limits>
+#include <stdio.h>
+#include <string.h>
+#include <errno.h>
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+namespace contrib {
+
+///------------------------------------------------------------------------
+/// \class GeneralEtSchemeRecombiner
+/// \brief Recombination scheme with generalized Et weighting
+///
+/// GeneralEtSchemeRecombiner defines a new recombination scheme by inheriting from JetDefinition::Recombiner.
+/// This scheme compares the pT of two input particles, and then combines them into a particle with
+/// a pT equal to the sum of the two particle pTs and a direction (in rapidity/phi) weighted by the respective momenta of the
+/// particle. The weighting is dependent on the power delta. For delta = infinity, this should return the same result as the
+/// WinnerTakeAllRecombiner.
+///------------------------------------------------------------------------
+class GeneralEtSchemeRecombiner : public fastjet::JetDefinition::Recombiner {
+public:
+
+   /// Constructor takes delta weighting
+   /// (delta = 1.0 for Et-scheme, delta = infinity for winner-take-all scheme)
+   GeneralEtSchemeRecombiner(double delta) : _delta(delta) {}
+  
+   /// Description
+   virtual std::string description() const;
+  
+   /// Recombine pa and pb and put result into pab
+   virtual void recombine(const fastjet::PseudoJet & pa,
+                         const fastjet::PseudoJet & pb, 
+                         fastjet::PseudoJet & pab) const;
+
+private:
+  double _delta;  ///< Weighting exponent
+};
+
+///------------------------------------------------------------------------
+/// \class WinnerTakeAllRecombiner
+/// \brief Recombination scheme with winner-take-all weighting
+///
+/// WinnerTakeAllRecombiner defines a new recombination scheme by inheriting from JetDefinition::Recombiner.
+/// This scheme compares the pT of two input particles, and then combines them into a particle with
+/// a pT equal to the sum of the two particle pTs and a direction (in rapidity/phi) identical to that of the harder
+/// particle. This creates a jet with an axis guaranteed to align with a particle in the event.
+///------------------------------------------------------------------------
+class WinnerTakeAllRecombiner : public fastjet::JetDefinition::Recombiner {
+public:
+   
+	/// Constructor to choose value of alpha (defaulted to 1 for normal pT sum)
+   WinnerTakeAllRecombiner(double alpha = 1.0) : _alpha(alpha) {}
+
+   /// Description
+   virtual std::string description() const;
+   
+   /// recombine pa and pb and put result into pab
+   virtual void recombine(const fastjet::PseudoJet & pa,
+                          const fastjet::PseudoJet & pb,
+                          fastjet::PseudoJet & pab) const;
+
+private:
+	double _alpha; //power of (pt/E) term when recombining particles
+};
+
+} //namespace contrib
+
+FASTJET_END_NAMESPACE
+
+#endif  // __FASTJET_CONTRIB_WINNERTAKEALLRECOMBINER_HH__
